(*

	Copyright  1989-1990 Larry S. Rosenstein.  All rights reserved.
	You may use this source code in your own Macintosh programs,
	but you may not redistribute or sell it.

*)

UNIT UShapeViewHelperImpl;

	{ This unit defines the TShapeViewHelper class, which is the heart of the graphics
		building block.  TShapeViewHelper implements the standard behavior of the building 
		block; that is, how all the pieces work together. 
		
	  You should call the following methods from the corresponding ones in TShapeView:
			CalcMinSize
			ContainsClipType
			DoHighlightSelection
			DoMenuCommand
			DoMouseCommand
			DoSetupMenus
			Draw
			GivePasteData
			WriteToDeskScrap
			
		See the implementation of TShapeView for details.
	  }
			
			
INTERFACE

USES
		Errors,
		UMacApp,
		UStream, UQuickDrawPattern, UShape,
		UShapeList, UShapeFilters, UShapeCommands, UShapeViewHelper;
		

IMPLEMENTATION

{$I UShapeViewHelper.inc1.p}

END.
