/*------------------------------------------------------------------------------

 MFAndNotification.r	-  Resources for the MFAndNotification Application

 Derez MFAndNotification.rsrc {RIncludes}SysTypes.r {RIncludes}Types.r > MFAndNotification/2.r

------------------------------------------------------------------------------*/
#include "Types.r"


resource 'SIZE' (0) {
	dontSaveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,
	multiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	acceptChildDiedEvents,
	is32BitCompatible,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	131072,
	131072
};

resource 'ALRT' (129, "MF Error", purgeable) {
	{80, 120, 165, 390},
	129,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound1,
		/* [2] */
		OK, visible, sound1,
		/* [3] */
		OK, visible, sound1,
		/* [4] */
		OK, visible, sound1
	}
};

resource 'DLOG' (128, "MF Count", locked, preload) {
	{380, 300, 470, 560},
	altDBoxProc,
	visible,
	noGoAway,
	0x0,
	128,
	"Compteur MF"
};

resource 'DITL' (129, "MF Error", purgeable) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{58, 191, 78, 251},
		Button {
			enabled,
			"Finder"
		},
		/* [2] */
		{8, 64, 24, 264},
		StaticText {
			disabled,
			"MultiFinder n'est pas install."
		}
	}
};

resource 'DITL' (128, "MF Count", locked, preload) {
	{	/* array DITLarray: 1 elements */
		/* [1] */
		{141, 54, 161, 114},
		Button {
			enabled,
			"New"
		}
	}
};

resource 'SICN' (1024) {
	{	/* array: 1 elements */
		/* [1] */
		$"3F E0 20 30 23 28 23 3C 23 04 23 04 20 04 E3 07"
		$"A0 05 BF FD 80 01 FF FF 80 01 80 05 80 01 FF FF"
	}
};

resource 'SICN' (128, "France", purgeable) {
	{	/* array: 1 elements */
		/* [1] */
		$"00 80 01 C0 23 62 21 C2 21 C2 21 C2 01 C0 21 C2"
		$"01 40 03 E0 03 E0 07 F0 0A A8 1F FC 3C 1E 78 0F"
	}
};

resource 'SICN' (0, purgeable) {
	{	/* array: 1 elements */
		/* [1] */
		$"00 00 01 00 03 80 07 C0 0F E0 1F F0 3F F8 7F FC"
		$"3F F8 1F F0 0F E0 07 C0 03 80 01"
	}
};

resource 'SICN' (-16385, purgeable) {
	{	/* array: 1 elements */
		/* [1] */
		$"10 84 08 88 00 00 04 90 50 05 07 F0 1C 1C 10 84"
		$"10 84 10 84 10 84 11 04 12 04 18 0C 07 F0 0F F8"
	}
};

